#include <stdio.h>
#include <stdlib.h>
#include <string.h>

typedef struct{
    unsigned den;
    unsigned mesic;
    unsigned rok;
}datum;
typedef struct{
    char name[51],sname[51];
    datum narozeni;
    unsigned telefon;
}kontakt;

void nactiData(kontakt *kam);
void pridej(kontakt osobu, FILE *kam);
int najdi(kontakt *osoba,char *jmeno,FILE* kde);
void vypisKontakt(kontakt osoba);
void vypisKartoteku(FILE *odkud);
void stripNL(char *string);

int main()
{
    FILE *file;
    int i=0,pocet=0;
    kontakt kamarad;
    file=fopen("kamaradi.dat","r+b");
    if(!file)
    {
        fopen("kamaradi.dat","w+b");
    }
    do
    {
        nactiData(&kamarad);
        if(strlen(kamarad.name)>0)
            pridej(kamarad,file);
        fflush(file);
    }while(strlen(kamarad.name)>0);
    pocet = i-1;
    char jmeno[51];
    printf("Zadejte hledane prijmeni:");
    fgets(jmeno,50,stdin);
   // char *nl=strchr(jmeno,'\n');
    stripNL(jmeno);
    kontakt hledany;
    if(najdi(&hledany,jmeno,file)){
        printf("Nalezen:\n");
        vypisKontakt(hledany);
    }
    else{
        printf("Nenalezen.\n");
    }
    vypisKartoteku(file);
    fclose(file);
}

void nactiData(kontakt *kam)
{
    printf("Jmeno:");
    fgets((*kam).name,50,stdin);
    stripNL((*kam).name);
    if(strlen(kam->name)==0)return;
    printf("Prijmeni:");
    fgets(kam->sname,50,stdin);
    stripNL(kam->sname);
    printf("Datum narozeni (dd-mm-rrrr):");
    scanf("%2u-%2u-%4u",&kam->narozeni.den,
                        &kam->narozeni.mesic,
                        &kam->narozeni.rok);
    getchar();
    printf("Tel:");
    scanf("%u",&kam->telefon);
    getchar();
}
void stripNL(char string[])
{
    char *nl = strchr(string,'\n');
    if(nl!=NULL)*nl='\0';
    else while(getchar()!='\n');
}

int najdi(kontakt *osoba,char *jmeno,FILE* kde)
{

    rewind(kde);

    while(!feof(kde))
    {
        fread(osoba,sizeof(kontakt),1,kde);
        if(strcmp(osoba->sname,jmeno)==0)
         return 1;
    }
    return -1;

}

void vypisKontakt(kontakt osoba)
{
    printf("Jmeno: %s %s\nDat. nar:%u. %u. %u\ntel:%u",
           osoba.name,osoba.sname,
           osoba.narozeni.den,osoba.narozeni.mesic,osoba.narozeni.rok,
           osoba.telefon);
}

void vypisKartoteku(FILE *odkud)
{
    kontakt kamarad;
    rewind(odkud);
    while(!feof(odkud))
    {
        fread(&kamarad,sizeof(kontakt),1,odkud);
        if(!feof(odkud))
          vypisKontakt(kamarad);
    }
}
void pridej(kontakt osobu,FILE *kam)
{
    fseek(kam,0,SEEK_END);
    fwrite(&osobu,sizeof(kontakt),1,kam);
}
